$(function() {
    // 입력창 엔터
    $('div.bottom div.emoji a').click(function() {
        channel.sendMessage({
            message: $(this).text(),
            mimeType: 'emoji'
        });
    });

    // 클릭 버튼
    $('#sendCounter').click(function(e) {
        channel.sendMessage({
            message: $('#content').text(),
            mimeType: "text"
        })
        $('#content').text('')
    })

    // 이모지 버튼
    $('#content').keydown(function(e) {
        if (e.keyCode == 13) {
            e.preventDefault();
            channel.sendMessage({
                message: $(this).text(),
                mimeType: "text"
            })
            $(this).text('');
        }
    })

    // 특정 유저로 메시지 전송
    var popupLayer = $('div.popupLayer');
    var whisperLayer = $('ul.popup_content li:nth-child(1)', $('div.popupLayer'));
    popupLayer.close = function() {
        $('#whisper input[type=text][name=message]', whisperLayer).val('');
        $("#whisper", this).hide();
        $(this).hide();
    }
    $('button', whisperLayer).click(function(e) {
        channel.sendWhisper({
            message: $('input[type=text][name=message]', whisperLayer).val(),
            receivedClientKey: popupLayer.data()['clientKey']
        }, function(err, msg) {
            if (err)
                return openError(err.message);
            write(msg, 'whisperto')
        })
        e.preventDefault();
        popupLayer.close();
    });
    // 신고하기
    $('ul.popup_content li:nth-child(2)', popupLayer).click(function(e) {
        // API 콜한다
        // https://vchatcloud.com/api/openapi/insertChatBanUser
        var url = "https://vchatcloud.com/api/openapi/insertChatBanUser";

        var param = {
            "room_id": popupLayer.data()['roomId'],
            "buser_nick": popupLayer.data()['nickName'],
            "buser_msg": popupLayer.data()['message'],
            "buser_chat_id": popupLayer.data()['clientKey']
        };
        console.log(param);
        $.post(url, param, function(data) {
            if (data.result_cd != 1) {
                console.log("추방 실패")
            }
        }, "json");
        popupLayer.close();
    });
})

function chatInit() {
    // 신규 메시지 이벤트
    channel.onNotifyMessage = function(event) {
        write(event)
    }

    // 개인 귓속말 메시지 이벤트
    channel.onPersonalWhisper = function(event) {
        write(event, 'whisper')
    }
}

function personalInit() {

    // 중복 로그인시 이벤트
    channel.onPersonalDuplicateUser = function(event) {
        vChatCloud.disconnect();
        openError("중복 로그인으로 인해 로그아웃합니다.", function() {
            $('div.enterypopup').show();
            $('div.chat_field').hide();
        });
    }

    // 글쓰기 제한 이벤트
    channel.onPersonalMuteUser = function(event) {
        openError("글쓰기가 제한되었습니다.")
    }

    // 글쓰기 제한 해제 이벤트
    channel.onPersonalUnmuteUser = function(event) {
        openError("글쓰기 제한이 해제되었습니다.")
    }
}

function msgInit() {
    // 공지사항 메시지
    channel.onNotifyNotice = function(event) {
        write(event, 'notice')
    }

    // 유저 입장
    channel.onNotifyJoinUser = function(event) {
        if (channel.clientKey != event.clientKey) {
            write(event, 'join')
        }
    }

    // 유저 나감
    channel.onNotifyLeaveUser = function(event) {
        write(event, 'leave')
    }

    // 유저 추방
    channel.onNotifyKickUser = function(event) {
        write("'<font color='blue'><b>" + event.nickName + "</b></font>' 님이 채팅방에서 추방되었습니다.");
    }

    // 유저 추방 해제
    channel.onNotifyUnkickUser = function(event) {
        write("'<font color='blue'><b>" + event.nickName + "</b></font>' 님이 채팅방에서 추방 해제되었습니다.");
    }

    // 글쓰기 제한
    channel.onNotifyMuteUser = function(event) {
        write("'<font color='blue'><b>" + event.nickName + "</b></font>' 님의 글쓰기가 제한되었습니다.");
    }

    // 글쓰기 제한 해제
    channel.onNotifyUnmuteUser = function(event) {
        write("'<font color='blue'><b>" + event.nickName + "</b></font>' 님의 글쓰기가 제한 해제되었습니다.");
    }

    // 커스텀 메시지
    channel.onNotifyCustom = function(event) {
        // {"roomId":"QljHXvApdB-hSKvfNLD2y-20200902153935","message":"{\"msg\":\"이벤트에 응모하시겠습니까?\",\"msgType\":\"event\",\"type\":\"popup\"}","nickName":"운영자","clientKey":"","mimeType":"text","messageDt":"20200904162501","messageCount":17}
        console.log('onNotifyCustom', JSON.stringify(event.message))
        try {
            var custom = JSON.parse(event.message)
            if (custom.type == "popup") {
                openPopup(custom.msg, function(val) {
                    console.log(val)
                }, false);
            } else if (custom.type == "notice") {
                write(custom.msg, 'notice')
            } else {
                openPopup(JSON.stringify(custom), function(val) {
                    console.log(val)
                }, true);
            }
        } catch (e) {
            openPopup(JSON.stringify(event.message), function(val) {
                console.log(val)
            }, true);
        }
    };
}
// $('a:nth-child(1)', $('div.custompopup')) 
function openPopup(msg, callback, option) {
    var p = $('div.custompopup').hide();
    $('p:nth-child(1)', p).text(msg);
    $('a:nth-child(2)', p).off().click(function() { p.hide(); if (typeof callback == 'function') { callback("확인") } });
    if (option) {
        $('a:nth-child(3)', p).hide()
    } else {
        $('a:nth-child(3)', p).off().click(function() { p.hide(); if (typeof callback == 'function') { callback("취소") } });
    }
    p.show();
}